#ifndef OBJECTGAME_H
#define OBJECTGAME_H

#include "IO_Block.h"
#include "eyecandy.h"
#include "object.h"
#include "player.h"

#include "objects/blocks/BounceBlock.h"
#include "objects/blocks/BreakableBlock.h"
#include "objects/blocks/DonutBlock.h"
#include "objects/blocks/FlipBlock.h"
#include "objects/blocks/NoteBlock.h"
#include "objects/blocks/OnOffSwitchBlock.h"
#include "objects/blocks/PowerupBlock.h"
#include "objects/blocks/SwitchBlock.h"
#include "objects/blocks/ThrowBlock.h"
#include "objects/blocks/ViewBlock.h"
#include "objects/blocks/WeaponBreakableBlock.h"

#include "objects/moving/WalkingEnemy.h"
#include "objects/moving/AttackZone.h"
#include "objects/moving/BonusHouseChest.h"
#include "objects/moving/Boomerang.h"
#include "objects/moving/BuzzyBeetle.h"
#include "objects/moving/CarriedObject.h"
#include "objects/moving/CheepCheep.h"
#include "objects/moving/Coin.h"
#include "objects/moving/CollectionCard.h"
#include "objects/moving/Fireball.h"
#include "objects/moving/FlagBase.h"
#include "objects/moving/FrenzyCard.h"
#include "objects/moving/Goomba.h"
#include "objects/moving/Hammer.h"
#include "objects/moving/IceBlast.h"
#include "objects/moving/Koopa.h"
#include "objects/moving/Podobo.h"
#include "objects/moving/Powerup.h"
#include "objects/moving/SledgeBrother.h"
#include "objects/moving/SledgeHammer.h"
#include "objects/moving/SpinAttack.h"
#include "objects/moving/Spiny.h"
#include "objects/moving/SuperFireball.h"
#include "objects/moving/Yoshi.h"

#include "objects/carriable/Flag.h"
#include "objects/carriable/Spring.h"
#include "objects/carriable/Bomb.h"
#include "objects/carriable/Egg.h"
#include "objects/carriable/KuriboShoe.h"
#include "objects/carriable/PhantoKey.h"
#include "objects/carriable/Shell.h"
#include "objects/carriable/Spike.h"
#include "objects/carriable/Star.h"
#include "objects/carriable/ThrowBlock.h"
#include "objects/carriable/ThrowBox.h"

#include "objects/overmap/Area.h"
#include "objects/overmap/BowserFire.h"
#include "objects/overmap/KingOfTheHillZone.h"
#include "objects/overmap/Phanto.h"
#include "objects/overmap/PipeBonus.h"
#include "objects/overmap/PipeCoin.h"
#include "objects/overmap/RaceGoal.h"
#include "objects/overmap/Thwomp.h"

#include "objects/powerup/BobombPowerup.h"
#include "objects/powerup/BombPowerup.h"
#include "objects/powerup/BoomerangPowerup.h"
#include "objects/powerup/BulletBillPowerup.h"
#include "objects/powerup/ClockPowerup.h"
#include "objects/powerup/CoinPowerup.h"
#include "objects/powerup/ExtraGuyPowerup.h"
#include "objects/powerup/ExtraHeartPowerup.h"
#include "objects/powerup/ExtraTimePowerup.h"
#include "objects/powerup/FeatherPowerup.h"
#include "objects/powerup/FirePowerup.h"
#include "objects/powerup/HammerPowerup.h"
#include "objects/powerup/IceWandPowerup.h"
#include "objects/powerup/JailKeyPowerup.h"
#include "objects/powerup/LeafPowerup.h"
#include "objects/powerup/ModPowerup.h"
#include "objects/powerup/MysteryMushroomPowerup.h"
#include "objects/powerup/PodoboPowerup.h"
#include "objects/powerup/PoisonPowerup.h"
#include "objects/powerup/PowPowerup.h"
#include "objects/powerup/PWingsPowerup.h"
#include "objects/powerup/SecretPowerup.h"
#include "objects/powerup/StarPowerup.h"
#include "objects/powerup/Tanooki.h"
#include "objects/powerup/TreasureChestBonus.h"

#include "objects/MysteryMushroomTempPlayer.h"

#endif // OBJECTGAME_H
